[libqglviewer] 05/07: Add autotest.

Anton Gladky gladk at moszumanska.debian.org
Tue May 6 21:20:01 UTC 2014


This is an automated email from the git hooks/post-receive script.

gladk pushed a commit to branch master
in repository libqglviewer.

commit 73ab38a4d740b72d07653063df11a32b4f097963
Author: Anton Gladky <gladk at debian.org>
Date:   Tue May 6 21:30:27 2014 +0200

    Add autotest.
---
 debian/control       |   1 +
 debian/tests/build1  | 115 +++++++++++++++++++++++++++++++++++++++++++++++++++
 debian/tests/control |   2 +
 3 files changed, 118 insertions(+)

diff --git a/debian/control b/debian/control
index 9aea8ea..5926d11 100644
--- a/debian/control
+++ b/debian/control
@@ -12,6 +12,7 @@ Build-Depends:
  libqt4-opengl-dev (>= 4:4.8.0~)
 Vcs-Git: git://anonscm.debian.org/gitweb/?p=debian-science/packages/libqglviewer.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/libqglviewer.git
+XS-Testsuite: autopkgtest
 
 Package: libqglviewer-dev
 Section: libdevel
diff --git a/debian/tests/build1 b/debian/tests/build1
new file mode 100755
index 0000000..2ac40d2
--- /dev/null
+++ b/debian/tests/build1
@@ -0,0 +1,115 @@
+#!/bin/sh
+# autopkgtest check: Build and run a program against libmedc
+# (C) 2013 Thomas Moulard
+# (C) 2014 Anton Gladky
+# Author: Thomas Moulard <thomas.moulard at gmail.com>
+#         Anton Gladky <gladk at debian.org>
+
+set -e
+
+WORKDIR=$(mktemp -d)
+trap "rm -rf $WORKDIR" 0 INT QUIT ABRT PIPE TERM
+cd $WORKDIR
+cat <<EOF > main.cpp
+#include "simpleViewer.h"
+#include <qapplication.h>
+
+int main(int argc, char** argv)
+{
+  // Read command lines arguments.
+  QApplication application(argc,argv);
+
+  // Instantiate the viewer.
+  Viewer viewer;
+
+  viewer.setWindowTitle("simpleViewer");
+
+  // Make the viewer window visible on screen.
+  viewer.show();
+
+  // Run main loop.
+  // return application.exec();
+}
+
+EOF
+
+cat <<EOF > simpleViewer.h
+#include <QGLViewer/qglviewer.h>
+
+class Viewer : public QGLViewer
+{
+protected :
+  virtual void draw();
+  virtual void init();
+  virtual QString helpString() const;
+};
+
+EOF
+
+cat <<EOF > simpleViewer.cpp
+#include "simpleViewer.h"
+
+using namespace std;
+
+// Draws a spiral
+void Viewer::draw()
+{
+  const float nbSteps = 200.0;
+
+  glBegin(GL_QUAD_STRIP);
+  for (int i=0; i<nbSteps; ++i)
+	{
+	  const float ratio = i/nbSteps;
+	  const float angle = 21.0*ratio;
+	  const float c = cos(angle);
+	  const float s = sin(angle);
+	  const float r1 = 1.0 - 0.8f*ratio;
+	  const float r2 = 0.8f - 0.8f*ratio;
+	  const float alt = ratio - 0.5f;
+	  const float nor = 0.5f;
+	  const float up = sqrt(1.0-nor*nor);
+	  glColor3f(1.0-ratio, 0.2f , ratio);
+	  glNormal3f(nor*c, up, nor*s);
+	  glVertex3f(r1*c, alt, r1*s);
+	  glVertex3f(r2*c, alt+0.05f, r2*s);
+	}
+  glEnd();
+}
+
+void Viewer::init()
+{
+  // Restore previous viewer state.
+  restoreStateFromFile();
+
+  // Opens help window
+  help();
+}
+
+QString Viewer::helpString() const
+{
+  QString text("<h2>S i m p l e V i e w e r</h2>");
+  text += "Use the mouse to move the camera around the object. ";
+  text += "You can respectively revolve around, zoom and translate with the three mouse buttons. ";
+  text += "Left and middle buttons pressed together rotate around the camera view direction axis<br><br>";
+  text += "Pressing <b>Alt</b> and one of the function keys (<b>F1</b>..<b>F12</b>) defines a camera keyFrame. ";
+  text += "Simply press the function key again to restore it. Several keyFrames define a ";
+  text += "camera path. Paths are saved when you quit the application and restored at next start.<br><br>";
+  text += "Press <b>F</b> to display the frame rate, <b>A</b> for the world axis, ";
+  text += "<b>Alt+Return</b> for full screen mode and <b>Control+S</b> to save a snapshot. ";
+  text += "See the <b>Keyboard</b> tab in this window for a complete shortcut list.<br><br>";
+  text += "Double clicks automates single click actions: A left button double click aligns the closer axis with the camera (if close enough). ";
+  text += "A middle button double click fits the zoom of the camera and the right button re-centers the scene.<br><br>";
+  text += "A left button double click while holding right button pressed defines the camera <i>Revolve Around Point</i>. ";
+  text += "See the <b>Mouse</b> tab and the documentation web pages for details.<br><br>";
+  text += "Press <b>Escape</b> to exit the viewer.";
+  return text;
+}
+
+EOF
+
+g++ -I/usr/include -I/usr/include/qt4/QtCore -I/usr/include/qt4/QtXml -I/usr/include/qt4/QtOpenGL -I/usr/include/qt4/QtGui -I/usr/include/qt4 -lQGLViewer -lQtOpenGL -lQtGui -lQtCore -lglut -lGLU -lGL -o simpleViewer simpleViewer.cpp main.cpp 
+
+echo "build: OK"
+[ -x simpleViewer ]
+./simpleViewer
+echo "run: OK"
diff --git a/debian/tests/control b/debian/tests/control
new file mode 100644
index 0000000..e50ba92
--- /dev/null
+++ b/debian/tests/control
@@ -0,0 +1,2 @@
+Tests: build1
+Depends: libqglviewer-dev, build-essential

-- 
Alioth's /usr/local/bin/git-commit-notice on /srv/git.debian.org/git/debian-science/packages/libqglviewer.git



More information about the debian-science-commits mailing list